/*
 * CTU Open 2009
 * Sample Solution: Arable Area
 * Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class aa {
	static final int MAX_SIZE = 200;
	static final int OFFSET = 100;
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		aa inst = new aa();
		while (inst.run()) {/* nothing */}
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	static class Squares {
		byte map[][] = new byte[MAX_SIZE][MAX_SIZE];
		int setx[] = new int[MAX_SIZE*MAX_SIZE], sety[] = new int[MAX_SIZE*MAX_SIZE];
		int count = 0;
		Squares() {
			for (int i = 0; i < MAX_SIZE; ++i)
				for (int j = 0; j < MAX_SIZE; ++j)
					map[i][j] = 0;
		}
		boolean check(int x, int y) {
			return map[x][y] != 0;
		}
		boolean set(int x, int y) {
			if (map[x][y] != 0) return false;
			map[x][y] = 1; setx[count] = x; sety[count++] = y;
			return true;
		}
		void erase() {
			for (int i = 0; i < count; ++i) map[setx[i]][sety[i]] = (byte)0;
			count = 0;
		}
	}
	Squares squares = new Squares();

	int linecnt;
	int[] linex, liney;

	boolean run() throws Exception {
		linecnt = nextInt();
		if (linecnt == 0) return false;
		linex = new int[linecnt+1]; liney = new int[linecnt+1];
		for (int i = 0; i < linecnt; ++i) {
			linex[i] = nextInt()+OFFSET; liney[i] = nextInt()+OFFSET;
		}
		linex[linecnt] = linex[0]; liney[linecnt] = liney[0];
		int sum1 = 0, sum2 = 0;
		for (int i = 0; i < linecnt; ++i) {
			if (linex[i] == linex[i+1]) continue;
			countSquares(linex[i], liney[i], linex[i+1], liney[i+1]);
			stroke -= countIgnored(i, linex[i], liney[i], linex[i+1], liney[i+1]);
			if (linex[i] < linex[i+1]) {
				sum1 -= below + stroke;
				sum2 += below;
			} else {
				sum1 += below;
				sum2 -= below + stroke;
			}
		}
		System.out.println((sum1 >= sum2) ? sum1 : sum2);
		return true;
	}

	int below; // number of squares completely below the line
	int stroke; // number of squares striken by this line
	void countSquares(int x1, int y1, int x2, int y2) {
		if (x1 > x2) { countSquares(x2, y2, x1, y1); return; }
		if (y1 > y2) { countSquares(x1, y2, x2, y1); return; }
		// here, x1<x2 and y1<=y2
		below = y1*(x2-x1);
		if (y1 == y2) { stroke = 0; return; }
		int x = x2-x1, y = y2-y1;
		int g = gcd(x, y), a = x * y;
		stroke = (x/g + y/g - 1) * g;
		below += (a - stroke) / 2;
	}

	/** Squares striken by a line AND also by another line _above_ this one. */
	int countIgnored(int idx, int x1, int y1, int x2, int y2) {
		for (int i = 0; i < linecnt; ++i) if (i != idx) {
			drawIfAbove(x1, y1, x2, y2, linex[i], liney[i], linex[i+1], liney[i+1]);
		}
		int res = drawLine(x1, y1, x2, y2, true);
		squares.erase();
		return res;
	}

	/** Draw line b but only if it is above a. */
	boolean drawIfAbove(int ax1, int ay1, int ax2, int ay2,
			int bx1, int by1, int bx2, int by2) {
		if (ax1 == ax2 || ay1 == ay2 || bx1 == bx2 || by1 == by2) return false;
		if (ax1 > ax2) return drawIfAbove(ax2, ay2, ax1, ay1, bx1, by1, bx2, by2);
		if (bx1 > bx2) return drawIfAbove(ax1, ay1, ax2, ay2, bx2, by2, bx1, by1);

		// ax1<ax2, bx1<bx2
		if (ax2 <= bx1 || bx2 <= ax1) return false;
		if (!isBelow(bx1, by1, bx2, by2, ax1, ay1, ax2, ay2)) return false;
		drawLine(bx1, by1, bx2, by2, false);
		return true;
	}

	/** ax1 &lt; ax2, bx1 &lt; bx2. return true if line b is "below" a */
	boolean isBelow(int ax1, int ay1, int ax2, int ay2,
			int bx1, int by1, int bx2, int by2) {
		return (vectprod(bx1-ax1, by1-ay1, ax2-ax1, ay2-ay1) >= 0
				&& vectprod(bx2-ax1, by2-ay1, ax2-ax1, ay2-ay1) >= 0) ||
				(vectprod(bx2-bx1, by2-by1, ax1-bx1, ay1-by1) >= 0
				&& vectprod(bx2-bx1, by2-by1, ax2-bx1, ay2-by1) >= 0);
	}

	/**
	 * @param tst true for "testing mode" (do not draw, only look)
	 * @return if tst was true, the number of non-zero fields encountered.
	 */
	int drawLine(int x1, int y1, int x2, int y2, boolean tst) {
		if (x1 == x2 || y1 == y2) return 0;
		if (x1 > x2) { return drawLine(x2,y2, x1,y1, tst); }
		int cnt = 0;
		boolean rev = (y1>y2); // line going down, not up
		if (rev) y2 = y1-(y2-y1);

		for (int x = x1, y = y1; x < x2 || y < y2; ) {
			int cp = vectprod(x-x1, y-y1, x2-x1, y2-y1);
			if (cp <= 0) ++x;
			if (cp >= 0) ++y;
			if (tst) {
				if (squares.check(x-1, rev ? y1-(y-y1) : y-1)) ++cnt;
			} else { 
				squares.set(x-1, rev ? y1-(y-y1) : y-1);
			}
		}
		return cnt;
	}

	int vectprod(int x1, int y1, int x2, int y2) {
		return x1*y2 - y1*x2;
	}

	static int gcd(int a, int b) {
		if (a < 0) return gcd(-a, b);
		if (b < 0) return gcd(a, -b);
		return (a < b) ? gcd2(b, a) : gcd2(a, b);
	}
	static int gcd2(int a, int b) {
		return (b == 0) ? a : gcd2(b, a%b);
	}
}
