/* Reseni ulohy Captcha v C++. 

   Jan Stoklasa - stoklja5@fit.cvut.cz - http://www.lisp.cz
*/

#include <stdio.h>
#include <string.h>

const int NPOS=4,
          NDIGITS=10,
          DIGITW=5,
          DIGITH=7,
          GAPW=2,
          DOTW=1,
          SCREENW=4*DIGITW+4*GAPW+DOTW,
          DOT_COLUMN=DIGITW+GAPW+DIGITW+GAPW;

int cols[NPOS]={0,
					 DIGITW+GAPW,
					 DIGITW+GAPW+DIGITW+GAPW+DOTW+GAPW,
					 DIGITW+GAPW+DIGITW+GAPW+DOTW+GAPW+DIGITW+GAPW
               };

const int TRAILINGNEWLINE=1;
const int TRAILINGZERO=1;
const int LINEW=SCREENW+TRAILINGZERO+TRAILINGNEWLINE;
char screen[DIGITH][SCREENW+TRAILINGNEWLINE+TRAILINGZERO];  //trailing \n\0 in input

char digits[NDIGITS][DIGITH][DIGITW+1]=
 {{"+---+",                   			
	"|   |",	                                
	"|   |",	                                    
	"+   +",	                                  
	"|   |",	                                              
	"|   |",	                                         
	"+---+"},  

  {"    +",	
	"    |",	
	"    |",	
	"    +",	
	"    |",	
	"    |",	
	"    +"},
  
  {"+---+",  
	"    |",	
	"    |",	
	"+---+",	
	"|    ",	
	"|    ",	  
	"+---+"},

  {"+---+",	
 	"    |",	
 	"    |",	
 	"+---+",	
 	"    |",	
 	"    |",	 
 	"+---+"},

  {"+   +", 
 	"|   |",	
 	"|   |",	
 	"+---+",	
 	"    |",	
 	"    |",	 
 	"    +"},

  {"+---+", 
	"|    ",	
	"|    ",	
	"+---+",	
	"    |",	
	"    |",	
	"+---+"},

  {"+---+", 
	"|    ",	
	"|    ",	
	"+---+",	
	"|   |",	
	"|   |",	
	"+---+"},

  {"+---+", 
	"    |",	
	"    |",	
	"    +",	
	"    |",	
	"    |",	
	"    +"},

  {"+---+", 
	"|   |",	
	"|   |",	
	"+---+",	
	"|   |",	
	"|   |",	
	"+---+"},

  {"+---+",	 
	"|   |",	 
	"|   |",	 
	"+---+",	 
	"    |",	 						  
	"    |",	 						  
	"+---+"}};
							
bool match_digit(int pos, int digit )
{
  for(int i=0;i<DIGITH;i++)
	 for(int j=0;j<DIGITW;j++)
	 {
		char c=screen[i][cols[pos]+j];
		if(c!='.' && c!=digits[digit][i][j])
		{
		  return false;
		}
	 }
  return true;
}

bool read_screen()
{
  if(!fgets(screen[0],LINEW,stdin) ||
	  strcmp("end",screen[0])==0)
  {
	 return false;
  } 
  screen[0][SCREENW]='\0';
  for(int i=1;i<DIGITH;i++)
  {
	 if(!fgets(screen[i],LINEW,stdin))
	 {
		return false;
	 }
	 screen[i][SCREENW]='\0';
  }
  char skip[SCREENW+1];
  return (fgets(skip,LINEW,stdin) &&
			 fgets(skip,LINEW,stdin));
}

int main() 
{
                              //0 1 2 3 4 5 6 7 8 9
  bool allowed[NPOS][NDIGITS]={{1,1,1,0,0,0,0,0,0,0},  //h1
										 {1,1,1,1,1,1,1,1,1,1},  //h2
										 {1,1,1,1,1,1,0,0,0,0},  //m1
										 {1,1,1,1,1,1,1,1,1,1}}; //m2

  bool matching_digits[NPOS][NDIGITS];
  int nmatching[NPOS];  

  while(read_screen())
  {
    memset(matching_digits,false,NPOS*NDIGITS*sizeof(bool));
	 memset(nmatching,0,NPOS*sizeof(int));
	 for(int p=0;p<NPOS;p++)
	 {
		for(int d=0;d<NDIGITS;d++)
		{	
		  if(match_digit(p,d) &&
			  allowed[p][d])
		  {
		     matching_digits[p][d]=true;
			  nmatching[p]++;
		  }
		  else
		  {
			  matching_digits[p][d]=false;
		  }
	 	}
	 }
	 if(nmatching[0]==1 && matching_digits[0][2])
	 {
		for(int d=4;d<NDIGITS;d++)
		{
		  if(matching_digits[1][d]==1)
		  {
		    matching_digits[1][d]=0;
			 nmatching[1]--;
		  }
		}
	 }
	 for(int d=4;d<NDIGITS;d++)
	 {
    	 if(matching_digits[1][d])
		 {
		   if(matching_digits[0][2])
		   {
		      matching_digits[0][2]=false;
			   nmatching[0]--;
		   } 
		 }
	 }

	 int solution[NPOS]={-1,-1,-1,-1};
	 bool ambiguous=false;
	 for(int p=0;p<NPOS;p++)
	 {
		for(int d=0;d<NDIGITS;d++)
		{
		  if(matching_digits[p][d] && solution[p]>=0)
		  {
			 ambiguous=true;
			 break;
		  }
		  else if(matching_digits[p][d])
		  {
			 solution[p]=d;
		  }
		}
	 }
	 if(ambiguous)
	 {
		puts("ambiguous");
	 }
	 else
	 {
		printf("%d%d:%d%d\n",solution[0],solution[1],solution[2],solution[3]);
	 }
  }
  puts("end");
  return 0;
}


