/*
 * CTU Open 2009
 * Sample Solution: Clock Captcha
 * Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.BitSet;

public class cc {
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		cc inst = new cc();
		while (inst.run()) /* nothing */;
		System.out.println("end");
	}
	
	String[][] DIGIT = {
		{"+---+", "|   |", "|   |", "+   +", "|   |", "|   |", "+---+"}, //0
		{"    +", "    |", "    |", "    +", "    |", "    |", "    +"}, //1
		{"+---+", "    |", "    |", "+---+", "|    ", "|    ", "+---+"}, //2
		{"+---+", "    |", "    |", "+---+", "    |", "    |", "+---+"}, //3
		{"+   +", "|   |", "|   |", "+---+", "    |", "    |", "    +"}, //4
		{"+---+", "|    ", "|    ", "+---+", "    |", "    |", "+---+"}, //5
		{"+---+", "|    ", "|    ", "+---+", "|   |", "|   |", "+---+"}, //6
		{"+---+", "    |", "    |", "    +", "    |", "    |", "    +"}, //7
		{"+---+", "|   |", "|   |", "+---+", "|   |", "|   |", "+---+"}, //8
		{"+---+", "|   |", "|   |", "+---+", "    |", "    |", "+---+"}, //9
	};
	
	char display[][] = new char[7][29];
	BitSet[] possible = new BitSet[4];
	{
		for (int i = 0; i < possible.length; ++i) possible[i] = new BitSet();
	}

	boolean run() throws Exception {
		String tm = input.readLine();
		if (tm == null || tm.length() < 29) {
			return false;
		}
		for (int x = 0; x < 7; ++x) {
			for (int y = 0; y < 29; ++y)
				display[x][y] = tm.charAt(y);
			tm = input.readLine();
		}
		input.readLine();
		
		scan(0, 0, possible[0], 3);
		scan(0, 7, possible[1], 10);
		scan(0, 17, possible[2], 6);
		scan(0, 24, possible[3], 10);
		String s = decide();
		System.out.println(s == null ? "ambiguous" : s);
		return true;
	}

	String decide() {
		if (possible[2].cardinality() > 1 || possible[3].cardinality() > 1) {
			return null;
		}
		String hour = null;
		for (int h1 = 0; h1 <= 2; ++h1) for (int h2 = 0; h2 < 10; ++h2) {
			if (h1 == 2 && h2 == 4) break;
			if (possible[0].get(h1) && possible[1].get(h2)) {
				if (hour != null) return null;
				hour = "" + h1 + h2;
			}
		}
		if (hour == null) throw new IllegalStateException("impossible");
		return hour + ":" + possible[2].nextSetBit(0) + possible[3].nextSetBit(0);
	}

	void scan(int x, int y, BitSet pos, int max) {
		pos.clear();
		for (int i = 0; i < max; ++i) {
			if (checkDigit(x, y, DIGIT[i])) pos.set(i);
		}
		if (pos.cardinality() == 0) throw new IllegalStateException("impossible");
	}

	boolean checkDigit(int x, int y, String[] dig) {
		for (int i = 0; i < 7; ++i)
			for (int j = 0; j < 5; ++j) {
				char ch = display[x+i][y+j];
				if (ch == '.') continue;
				if (ch != dig[i].charAt(j)) return false;
			}
		return true;
	}
}
