/*
 * CTU Open 2009
 * Sample Solution: Identifiers
 * Martin Kacer
 */


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.regex.Pattern;

public class ii {
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

	final static String RES_M = "boy", RES_F = "girl", RES_ERR = "invalid";
	final static Pattern PATT = Pattern.compile("[0-9]{6}/[0-9]{3,4}");
	final static int MON_DAY[] = new int[]{31,28,31,30,31,30,31,31,30,31,30,31};

	public static void main(String[] args) throws Exception {
		ii inst = new ii();
		while (inst.run()) /* nothing */;
	}
	
	boolean run() throws Exception {
		String s = input.readLine();
		if (s == null || "end".equalsIgnoreCase(s)) return false;
		System.out.println(verify(s));
		return true;
	}

	String verify(String s) {
		if (!PATT.matcher(s).matches()) return RES_ERR + debug("pattern");
		int yy = Integer.valueOf(s.substring(0,2));
		int mm = Integer.valueOf(s.substring(2,4));
		int dd = Integer.valueOf(s.substring(4,6));
		int len = s.length() - 7;
		String gender = RES_M;
		if (mm > 50) { mm -= 50; gender = RES_F; }
		if (yy < 10) yy += 2000; else yy += 1900;
		if (yy < 1954) {
			if (len != 3) return RES_ERR + debug("not 3");
		} else {
			if (len != 4) return RES_ERR + debug("not 4");
			long chk = Long.valueOf(s.substring(0, 6) + s.substring(7));
			if (chk % 11 != 0) return RES_ERR + debug("checksum");
		}
		if (yy < 1920 || yy >= 2010) return RES_ERR + debug("year");
		if (mm < 1 || mm > 12) return RES_ERR + debug("month");
		int max = MON_DAY[mm-1];
		if (mm == 2 && yy % 4 == 0) ++max;
		if (dd < 1 || dd > max) return RES_ERR + debug("day");
		return gender;
	}

	String debug(String s) {
		return "";
	}
}
