/*
 * CTU Open 2009
 * Sample Solution: Odd Opportunities
 * Zdenek Dvorak
 */   
   

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAX_VERTS 10000

struct edge
{
  int to;
  struct edge *next;
};

int n, m;
char parity[MAX_VERTS + 1];
char visited[MAX_VERTS];
int output[MAX_VERTS][2];
int nout;
struct edge *graph[MAX_VERTS];

static void
add_edge (int u, int v)
{
  struct edge *e;

  e = (struct edge*) malloc (sizeof (struct edge));
  e->to = v;
  e->next = graph[u];
  graph[u] = e;

  e = (struct edge*) malloc (sizeof (struct edge));
  e->to = u;
  e->next = graph[v];
  graph[v] = e;
}

static void
free_graph (void)
{
  int i;
  struct edge *e, *nx;

  for (i = 0; i < n; i++)
    {
      for (e = graph[i]; e; e = nx)
	{
	  nx = e->next;
	  free (e);
	}
      graph[i] = NULL;
    }
}

static int
keep_edge_to_father (int v)
{
  int sonp = 0;
  struct edge *e;

  visited[v] = 1;
  for (e = graph[v]; e; e = e->next)
    {
      if (visited[e->to])
	continue;

      if (keep_edge_to_father (e->to))
	{
	  output[nout][0] = v;
	  output[nout][1] = e->to;
	  nout++;
	  sonp = !sonp;
	}
    }

  return sonp ^ (parity[v] == 'o');
}

int main(void)
{
  int i, u, v;

  while (1)
    {
      scanf ("%d%d", &n, &m);
      if (!n)
	return 0;

      for (i = 0; i < m; i++)
	{
	  scanf ("%d%d", &u, &v);
	  add_edge (u - 1, v - 1);
	}
      scanf ("%s", parity);

      for (i = 0; i < n; i++)
	if (!visited[i])
	  if (keep_edge_to_father (i))
	    break;

      if (i != n)
	printf ("impossible\n");
      else
	{
	  printf ("%d\n", nout);
	  for (i = 0; i < nout; i++)
	    {
	      u = output[i][0];
	      v = output[i][1];
	      printf ("%d %d\n", u + 1, v + 1);
	    }
	}

      free_graph ();
      nout = 0;
      memset (visited, 0, n);
    }
}

