/**
 * CTU Open Contest 2009
 * Solution for the problem: Primes.
 * October, 2009
 *
 * @author Jan Stoklasa
 */

import java.lang.Long;
import java.util.ArrayList;
import java.util.LinkedList;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class pp {  

static class ProblemInstance
{
    public int x;
    public int y;
    public int primes[];
}   

static class ListOfLongs extends LinkedList<Long>   // avoid the Java typesystem "generic array creation" error
{
	 private static final long serialVersionUID = 1L; //shut up the warning
}

static class LazyStream
{
    ListOfLongs nums[];
    int primes[];
    long lastn;

    LazyStream(int p[])
    {
        primes=p;
		  nums=new ListOfLongs[p.length];
        for(int i=0;i<nums.length;i++)
        {
            nums[i]=new ListOfLongs();
        }
        if(nums.length>0)
        {
           nums[0].addLast(1L);
        }
        for(int i=0;i<nums.length;i++)
        {
            nums[i].addLast((long)primes[i]);
        }
        lastn=-1;
    }
    
    public long merge()
    {
        long min=Long.MAX_VALUE;
        int idx=-1;
        for(int i=0;i<nums.length;i++)
        {
            long n=nums[i].peek();
            if(n<=min)
            {
                min=n;
                idx=i;
            }
        }
        if(idx>=0)
        {
            nums[idx].poll();
        }
        return min;
    }
    
    public long next()
    {
        long n;
        while((n=merge())==lastn)   //skip duplicates
        {
        }
        lastn=n;
        for(int i=0;i<nums.length;i++)
        {
            nums[i].addLast(primes[i]*n);   
        }
        return n;
    }
}

    static StringTokenizer st = new StringTokenizer("");
    static BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    static String nextToken() throws Exception {
        while (!st.hasMoreTokens()) 
          st = new StringTokenizer(input.readLine());
        return st.nextToken();
    }
    
    static int nextInt() throws Exception {
		  return Integer.parseInt(nextToken());
    }
        
    static ProblemInstance parse() {
		  try 
		  {
				ProblemInstance pi=new ProblemInstance();
				int NPrimes=nextInt();
				if(NPrimes<=0)
				{
				   return null;
				}
				pi.primes=new int[NPrimes];
				for(int i=0;i<NPrimes;i++)
				{		
					pi.primes[i]=nextInt();
				}
				pi.x=nextInt();
				pi.y=nextInt();
            return pi;
		  }
		  catch(Exception ex)
		  {
				return null;
		  }
    }
    
    public static void main(String[] args) {
		  ProblemInstance pi=null;
        while((pi=parse())!=null)
        {            
            boolean none=true;  
            LazyStream lazystream=new LazyStream(pi.primes);
            long i;  
            while((i=lazystream.next())<pi.x)
            {
            }
            if(i<=pi.y)
            {
                none=false;
                System.out.print(i);
            }
            while((i=lazystream.next())<=pi.y)
            {
                none=false;
                System.out.print(",");
                System.out.print(i);
            }
            if(none)
            {
                System.out.print("none");
            }
            System.out.println("");
        }
		  System.exit(0);
    }
}
